(********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Package: NewPackage
 * File: Global8VS.typ
 * Author: liub
 * Created: September 11, 2014
 ********************************************************************
 * Data types of package NewPackage
 ********************************************************************)

TYPE
	STATE_MACHINE_ENUM : 
		(
		STATUS_NOT_READY_TO_SWITCH_ON := 0,
		STATUS_SWITCH_ON_DISABLE := 1,
		STATUS_READY_TO_SWITCH_ON,
		STATUS_SWITCH_ON,
		STATUS_OPERATION_ENABLE,
		STATUS_QUICK_STOP_ACTIVE,
		STATUS_FAULT_REACTION_ACTIVE,
		STATUS_FAULT
		);
	SDO_STATE_ENUM_INIT : 
		(
		STATE_INIT_WAIT := 0,
		STATE_INIT_WRITE_HOMEMODE,
		STATE_INIT_WRITE_HOMESPEEDLOW,
		STATE_INIT_WRITE_HOMESPEEDFAST,
		STATE_INIT_WRITE_HOMEACCEL,
		STATE_INIT_WRITE_HOMEDECEL,
		STATE_INIT_WRITE_ESTOP_DEC,
		STATE_INIT_WRITE_FINISH,
		STATE_INIT_WRITE_ERROR
		);
	SDO_STATE_ENUM_CHANGE : 
		(
		STATE_CHANGE_WAIT := 0,
		STATE_CHANGE_WRITE_HOMEMODE,
		STATE_CHANGE_WRITE_HOMESPEEDLOW,
		STATE_CHANGE_WRITE_HOMESPEEDFAST,
		STATE_CHANGE_WRITE_HOMEACCEL,
		STATE_CHANGE_WRITE_HOMEDECEL,
		STATE_CHANGE_WRITE_ESTOP_DEC,
		STATE_CHANGE_WRITE_FINISH,
		STATE_CHANGE_WRITE_ERROR
		);
	HOME_STATE_ENUM : 
		(
		STATE_HOME_WAIT := 0,
		STATE_HOME_CHANGE_TO_HOME_MODE,
		STATE_HOME_POWER_ON_1,
		STATE_HOME_POWER_ON_2,
		STATE_HOME_POWER_ON_3,
		STATE_HOME_HOMING,
		STATE_HOME_FINISH,
		STATE_HOME_CHANGE_TO_CSP_MODE,
		STATE_HOME_POWER_OFF,
		STATE_HOME_SAVE_PARAMETER,
		STATE_HOME_WAIT_FOR_END,
		STATE_HOME_DIRECT,
		STATE_HOME_ERROR
		);
	sdcAxisCfg_typ : 	STRUCT 
		deviceName : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF STRING[32]; (*Use to read/write parameter*)
		nodeNumber : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF USINT; (*Use to read/write parameter*)
		moveMode : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SINT;
		sdcHwCfg : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcHwCfg_typ;
		encIf : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcEncIf32_typ; (*Encoder interface*)
		drvIf : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcDrvIf32_typ; (*driver interface*)
		trigger1If : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcTrigIfDIGin_typ;
		trigger2If : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcTrigIfDIGin_typ;
		dioIf : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SdcDiDoIf_typ; (*di do interface*)
	END_STRUCT;
	sdcAxisMonitor_typ : 	STRUCT  (*Position information*)
		setPosIncIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF DINT; (*[increments] Set Position to io-mapping*)
		actPosIncIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF DINT; (*[increments] Act Position to io-mapping*)
	END_STRUCT;
	sdcAxisStatus_typ : 	STRUCT 
		statusWordIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF UINT; (*Status word to io-mapping*)
		controlWordIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF UINT; (*Ctrl word to io-mapping*)
		moveModeDisplay : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF SINT;
		moduleOkIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF BOOL; (*IO-mapping*)
		errorNumberIO : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF UINT; (*Current error number*)
		stateMachine : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF STATE_MACHINE_ENUM; (*current status translate from status word, easy to understand*)
		voltage : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF BOOL; (*drive 380V power*)
		touchProbeOffset : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF DINT;
		posOffset : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF DINT; (*internal use*)
		initOK : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF USINT; (*set sdo para init value*)
		digitalInputs : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF UDINT;
	END_STRUCT;
	sdcAxisCmd_typ : 	STRUCT 
		ackError : ARRAY[0..SDC_AXIS_NB_MINUS_ONE]OF BOOL;
	END_STRUCT;
	sdcAxisCtrl_typ : 	STRUCT 
		cmd : sdcAxisCmd_typ;
		cfg : sdcAxisCfg_typ;
		monitor : sdcAxisMonitor_typ;
		status : sdcAxisStatus_typ;
	END_STRUCT;
END_TYPE
