/********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Program: sdcCtrl
 * File: sdcCtrl.c
 * Author: liub
 * Created: September 09, 2014
 ********************************************************************
 * Implementation of program sdcCtrl
 ********************************************************************/

#include <bur/plctypes.h>


#ifdef _DEFAULT_INCLUDES
#include <AsDefault.h>
#endif
 
/* Cia 402 Complete Mode. Now 8VS maybe not support all*/
/*0 No mode change/no mode assigned
+1 Profile position mode
+2 Velocity mode
+3 Profile velocity mode
+4 Profile Torque mode
+5 reserved
+6 Homing mode
+7 Interpolated position mode
+8 Cyclic sync position mode
+9 Cyclic sync velocity mode
+10 Cyclic sync torque mode */


#define STATUSWORD_AND_MASK                 0x006f          
#define STATUSWORD_NOTREADYTOSWITCHON       0x0000
#define STATUSWORD_SWITCHEDONDISABLED_1     0x0040         
#define STATUSWORD_SWITCHEDONDISABLED_2     0x0060         
#define STATUSWORD_READYTOSWITCHON          0x0021	       
#define STATUSWORD_SWITCHEDON               0x0023         
#define STATUSWORD_OPERATIONENABLED         0x0027         
#define STATUSWORD_QUICKSTOPACTIVE          0x0007        
#define STATUSWORD_FAULTREACTIONACTIVE      0x000F         
#define STATUSWORD_FAULT_1                  0x0008 
#define STATUSWORD_FAULT_2                  0x0028 
#define STATUSWORD_VOLTAGE                  0x0010


void _INIT sdcCtrlINIT(void)
{
	
	fRTInfo.enable = 1;
	RTInfo(&fRTInfo);
	cycT = fRTInfo.cycle_time;			
	for(axisIndex=0;axisIndex<SDC_AXIS_NB;axisIndex++)
		{
		gSdcAxisCtrl.cfg.moveMode[axisIndex] = MOVE_MODE_CYC_POSITION; 
		/****************SDC ӿڳʼ***************************/
		gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].EncIf1_Typ = ncSDC_ENC32;    /**/
        
		memset(&tempString,0,sizeof(tempString)); 
		strcpy(&tempString,"gSdcAxisCtrl.cfg.encIf["); 
		if(axisIndex < 10)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
				{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex;
			tempString[stringIndex+1] = ']';
		}
		else if(axisIndex < 99)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
				{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex/10;
			tempString[stringIndex+1] = '0'+axisIndex%10;
			tempString[stringIndex+2] = ']';     
		}
		strcpy(&gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].EncIf1_Name[0],&tempString);
		/****************SDC Driver ӿڳʼ***************************/    
		gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].DrvIf_Typ = ncSDC_DRVSM32;
		memset(&tempString,0,sizeof(tempString));
		strcpy(&tempString,"gSdcAxisCtrl.cfg.drvIf[");
		if(axisIndex < 10)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
				{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex;
			tempString[stringIndex+1] = ']';
		}
		else if(axisIndex < 99)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
				{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex/10;
			tempString[stringIndex+1] = '0'+axisIndex%10;
			tempString[stringIndex+2] = ']';       
		}
		strcpy(&gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].DrvIf_Name[0],&tempString); 
		/****************SDC Dio ӿڳʼ***************************/   
		gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].DiDoIf_Typ = ncSDC_DIDO;
		memset(&tempString,0,sizeof(tempString));
		strcpy(&tempString,"gSdcAxisCtrl.cfg.dioIf[");
		if(axisIndex < 10)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
				{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex;
			tempString[stringIndex+1] = ']';
		}
		else if(axisIndex < 99)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
				{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex/10;
			tempString[stringIndex+1] = '0'+axisIndex%10;
			tempString[stringIndex+2] = ']';        
		}
		strcpy(&gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].DiDoIf_Name[0],&tempString); 
		
		/****************SDC Trigger ӿڳʼ************************** */  	
		gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].TrigIf1_Typ= ncSDC_TRIGDIGin;		
		memset(&tempString,0,sizeof(tempString));
		strcpy(&tempString,"gSdcAxisCtrl.cfg.trigger1If[");
		if(axisIndex < 10)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
			{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex;
			tempString[stringIndex+1] = ']';
		}
		else if(axisIndex < 99)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
			{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex%10;
			tempString[stringIndex+1] = '0'+axisIndex/10;
			tempString[stringIndex+2] = ']';       
		}		    
		strcpy(&gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].TrigIf1_Name[0],&tempString); 
		
		gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].TrigIf2_Typ= ncSDC_TRIGDIGin;
		memset(&tempString,0,sizeof(tempString));
		strcpy(&tempString,"gSdcAxisCtrl.cfg.trigger2If[");
		if(axisIndex < 10)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
			{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex;
			tempString[stringIndex+1] = ']';
		}
		else if(axisIndex < 99)
		{
			for(stringIndex = 0;stringIndex<sizeof(tempString);stringIndex++)
			{
				if(tempString[stringIndex] == 0)break;
			}
			tempString[stringIndex] = '0'+axisIndex%10;
			tempString[stringIndex+1] = '0'+axisIndex/10;
			tempString[stringIndex+2] = ']';       
		}				
		strcpy(&gSdcAxisCtrl.cfg.sdcHwCfg[axisIndex].TrigIf2_Name[0],&tempString);
	}
	/****************SDO ʼ***************************/   
	for(axisIndex=0;axisIndex<SDC_AXIS_NB;axisIndex++)
		{
		strcpy(&gSdcAxisCtrl.cfg.deviceName[axisIndex],SDC_AXIS_DEVICE_NAME);   /*Get device name*/
		gSdcAxisCtrl.cfg.nodeNumber[axisIndex] = SDC_AXIS_NODE_NUMBER[axisIndex];   /*Get node number*/
		gSdcAxisCtrl.cmd.ackError[axisIndex]=1; 
	}
}


void _CYCLIC sdcCtrlCYCLIC(void)
{   

	/*sdc ӿڱ*/
	for(axisIndex=0;axisIndex<SDC_AXIS_NB;axisIndex++)
		{
		/*ӿ*/
		gSdcAxisCtrl.cfg.encIf[axisIndex].iLifeCnt++;     /**/
		gSdcAxisCtrl.cfg.encIf[axisIndex].iEncOK = 1;     /**/
		gSdcAxisCtrl.cfg.encIf[axisIndex].iActTime = gSdcAxisCtrl.cfg.drvIf[axisIndex].oSetTime;  
		gSdcAxisCtrl.cfg.encIf[axisIndex].iActPos = gSdcAxisCtrl.monitor.actPosIncIO[axisIndex];     /*ͨIO-Mappingȡ*/
		//gSdcAxisCtrl.cfg.encIf[axisIndex].iActPos = gSdcAxisCtrl.monitor.setPosIncIO[axisIndex];     /*ͨIO-Mappingȡ*/
		/*ӿ*/
		gSdcAxisCtrl.cfg.drvIf[axisIndex].iLifeCnt++;     /**/
		if(gSdcAxisCtrl.status.stateMachine[axisIndex] != STATUS_NOT_READY_TO_SWITCH_ON)/*״̬ Ready to switch on ===== switch off*/
		{
			gSdcAxisCtrl.cfg.drvIf[axisIndex].iDrvOK = 1;
		}
		else
		{
			gSdcAxisCtrl.cfg.drvIf[axisIndex].iDrvOK = 0;
		}  
        gSdcAxisCtrl.cfg.dioIf[axisIndex].iLifeCntDriveEnable++;      /**/
		gSdcAxisCtrl.cfg.dioIf[axisIndex].iLifeCntNegHwEnd++;         /**/
		gSdcAxisCtrl.cfg.dioIf[axisIndex].iLifeCntPosHwEnd++;         /**/
		gSdcAxisCtrl.cfg.dioIf[axisIndex].iLifeCntReference++;        /**/
		gSdcAxisCtrl.cfg.dioIf[axisIndex].iLifeCntDriveReady++;
		if(gSdcAxisCtrl.status.stateMachine[axisIndex] == STATUS_OPERATION_ENABLE)/*״̬ Operation enable ===== switch on*/
		{
			gSdcAxisCtrl.cfg.dioIf[axisIndex].iDriveReady = 1 ;
		}
		else
		{
			gSdcAxisCtrl.cfg.dioIf[axisIndex].iDriveReady = 0;
		}
		/*Trigger1/2ӿڣ൱ڻPLCLatch*/
		DI3[axisIndex]=(gSdcAxisCtrl.status.digitalInputs[axisIndex] & 0x00080000)>>19;
		DI1[axisIndex]=(gSdcAxisCtrl.status.digitalInputs[axisIndex] & 0x00020000)>>17;
		DI2[axisIndex]=(gSdcAxisCtrl.status.digitalInputs[axisIndex] & 0x00040000)>>18;
		gSdcAxisCtrl.cfg.trigger1If[axisIndex].iLifeCnt++;
		gSdcAxisCtrl.cfg.trigger1If[axisIndex].iTriggerInput=DI1[axisIndex];
		gSdcAxisCtrl.cfg.trigger2If[axisIndex].iLifeCnt++;
		gSdcAxisCtrl.cfg.trigger2If[axisIndex].iTriggerInput=DI2[axisIndex];	
	}
	/*״̬ --------״ֿ̬*/
	for(axisIndex=0;axisIndex<SDC_AXIS_NB;axisIndex++)
		{        
		/*ȡ״̬ж״̬Ҫλ bit 0,1,2,3,5,6*/
		/*Bits 0, 1, 2, 3, 5 and 6 are used to determine the drive state with respect to the DS 402 state machine*/
		statusWordAnd[axisIndex] = (gSdcAxisCtrl.status.statusWordIO[axisIndex] & STATUSWORD_AND_MASK);
		/*ȡ״̬λ*/
		gSdcAxisCtrl.status.voltage[axisIndex] = (gSdcAxisCtrl.status.statusWordIO[axisIndex] & STATUSWORD_VOLTAGE)?1:0;
        
		switch(statusWordAnd[axisIndex])
		{   
			case STATUSWORD_NOTREADYTOSWITCHON:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_NOT_READY_TO_SWITCH_ON;
				break;
			case STATUSWORD_SWITCHEDONDISABLED_1:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_SWITCH_ON_DISABLE;
				break;
			case STATUSWORD_SWITCHEDONDISABLED_2:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_SWITCH_ON_DISABLE;
				break;
			case STATUSWORD_READYTOSWITCHON:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_READY_TO_SWITCH_ON;    /*switch off*/  
				break;
			case STATUSWORD_SWITCHEDON:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_SWITCH_ON;
				break;
			case STATUSWORD_OPERATIONENABLED:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_OPERATION_ENABLE;      /*switch on*/
				break;
			case STATUSWORD_QUICKSTOPACTIVE:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_QUICK_STOP_ACTIVE;
				break;
			case STATUSWORD_FAULTREACTIONACTIVE:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_FAULT_REACTION_ACTIVE;
				break;
			case STATUSWORD_FAULT_1:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_FAULT;
				break;
			case STATUSWORD_FAULT_2:
				gSdcAxisCtrl.status.stateMachine[axisIndex] = STATUS_FAULT;
				break;
			default:
				/*status can not understand,should not happen*/
				break;
		}
		/*֧bit1 bit3ͬʱ趨Ϊ1*/
		if (gSdcAxisCtrl.cfg.dioIf[axisIndex].oDriveEnable == 1)
		{
			if(gSdcAxisCtrl.status.stateMachine[axisIndex] == STATUS_SWITCH_ON)	oDriveEnableDelay[axisIndex] = 1;
		}
		else
		{	oDriveEnableDelayCnt[axisIndex] = 0;
			oDriveEnableDelay[axisIndex] = 0;
		}			
		/*Ϳ*/
		/*Bits 0-3 and 7 are used for state control, generating commands to which the drive will respond. These commands
		control the transitions in the DS 402 state machine	*/
		gSdcAxisCtrl.status.controlWordIO[axisIndex] = ((gSdcAxisCtrl.status.moduleOkIO[axisIndex]<<1) + (gSdcAxisCtrl.status.moduleOkIO[axisIndex]<<2) + 
				(gSdcAxisCtrl.cfg.dioIf[axisIndex].oDriveEnable	) + (oDriveEnableDelay[axisIndex]<<3) + (gSdcAxisCtrl.cmd.ackError[axisIndex]<<7));
		/*λƫƴ*/	
		if(gSdcAxisCtrl.status.stateMachine[axisIndex] != STATUS_OPERATION_ENABLE) 
		{
			gSdcAxisCtrl.status.posOffset[axisIndex] = gSdcAxisCtrl.monitor.actPosIncIO[axisIndex] - gSdcAxisCtrl.cfg.drvIf[axisIndex].oSetPos;
		}
		gSdcAxisCtrl.monitor.setPosIncIO[axisIndex] = gSdcAxisCtrl.cfg.drvIf[axisIndex].oSetPos + gSdcAxisCtrl.status.posOffset[axisIndex];

		/*ʱλȷ*/
		if(gSdcAxisCtrl.cmd.ackError[axisIndex] == 1)  
		{
			errorResetDelay[axisIndex] += cycT;    /*us*/
		}
		if(errorResetDelay[axisIndex] > ERROR_RESET_DELAY_TIME) gSdcAxisCtrl.cmd.ackError[axisIndex] = 0;
	

		
		

	}
}
